<template>
  <div >
    <h1 class="text-center mt-10 text-4xl">
      Tareas del  {{ responseCurso.nombre }}
    </h1>
    <div class="bg-secondary m-auto w-2/4 rounded-3xl min-h-min">
      <h1 class="text-center mt-10 text-3xl">
        {{ responseAsig.tipoAsignatura }}
      </h1>
    </div>
    <div class="text-sm breadcrumbs ml-12 mt-10">
    <ul>
      <li>
        <a
          @click="
            $router.push({
              path: elegirAsignaturaURL,
            })
          "
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            class="w-4 h-4 mr-2 stroke-current"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"
            ></path>
          </svg>
          Elegir Asignatura
        </a>
      </li>
      <li>
        <a
          @click="
            $router.push({
              path: elegirCursoURL,
              query: { asig_id: this.$route.query.asig_id },
            })
          "
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            class="w-4 h-4 mr-2 stroke-current"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"
            ></path>
          </svg>
         Elegir Curso
        </a>
      </li>
      <li>
        <a
          @click="
            $router.push({
              path: listaTareasURL,
              query: { asig_id: this.$route.query.asig_id, curso_id: this.$route.query.curso_id },
            })
          "
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            class="w-4 h-4 mr-2 stroke-current"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"
            ></path>
          </svg>
          Lista Tareas
        </a>
      </li>
      
    </ul>
  </div>
    <div class="overflow-x-auto w-full text-center">
      <table v-if="tareas.length > 0" class="table w-4/6 mt-14 m-auto">
        <!-- head -->
        <thead>
          <tr>
            <th>
              <label>
                <input type="checkbox" class="checkbox" />
              </label>
            </th>
            <th>Nombre Tarea</th>
            <th>Descripción</th>
            <th>Fecha Entrega</th>

            <th></th>
          </tr>
        </thead>

        <tbody v-for="tarea in tareas" :key="tarea.tareaId">
          <tr class="hover">
            <th>
              <label>
                <input type="checkbox" class="checkbox" />
              </label>
            </th>
            <td
              @click="
                $router.push({
                  path: 'DetalleTareaDocente',
                  query: {
                    asig_id: routeasign,
                    curso_id: route,
                    tarea_id: tarea.tareaId,
                  },
                })
              "
            >
              <div class="flex items-center space-x-3">
                <div>
                  <div class="font-bold">{{ tarea.nombreTarea }}</div>
                </div>
              </div>
            </td>
            <td
              class="w-44"
              @click="
                $router.push({
                  path: 'DetalleTareaDocente',
                  query: {
                    asig_id: routeasign,
                    curso_id: route,
                    tarea_id: tarea.tareaId,
                  },
                })
              "
            >
              {{ tarea.descTarea.substring(0, 50) + "..." }}

              <br />
            </td>
            <td
              @click="
                $router.push({
                  path: 'DetalleTareaDocente',
                  query: {
                    asig_id: routeasign,
                    curso_id: route,
                    tarea_id: tarea.tareaId,
                  },
                })
              "
            >
              {{ tarea.fechTermino.substring(0, 10) }}
            </td>

            <th>
              <button
                class="btn btn-ghost btn-xs hover:bg-warning"
                @click="
                  $router.push({
                    path: 'ModificarTarea',
                    query: {
                      asig_id: routeasign,
                      curso_id: route,
                      tarea_id: tarea.tareaId,
                    },
                  })
                "
              >
                Editar
              </button>
              <button
                class="btn btn-ghost btn-xs hover:bg-error"
                @click="eliminarTarea(tarea.tareaId)"
              >
                Eliminar
              </button>
            </th>
          </tr>
        </tbody>

        <tfoot>
          <tr>
            <th></th>
            <th>NOMBRE TAREA</th>
            <th>Descripción</th>
            <th>Fecha Entrega</th>

            <th></th>
          </tr>
        </tfoot>
      </table>
      <div
        v-else
        class="text-center bg-secondary w-2/4 m-auto rounded-xl h-auto items-align-center align-middle"
      >
        <h1 class="text-2xl mt-24 font-bold">
          No se encuentran tareas en el curso seleccionado
        </h1>
      </div>
    </div>
  </div>
</template>
<script>
import axios from "axios";
export default {
  components: {},
  data() {
    return {
      route: this.$route.query.curso_id,
      routeasign: this.$route.query.asig_id,
      tareas: [],
      responseAsig: [],
      responseCurso: [],
      asig: [],
      elegirAsignaturaURL:"",
      elegirCursoURL:"",
      listaTareasURL:""
    };
  },

  mounted() {
    let ruta = this.$route.path;
    console.log(this.$route.path);
    const curso = "";
    const fecha = "";
    const hora = "";
    const fechaCompleta = "";
    const msg = "";
    let vue = this;
    const peticion = this.$route.query.asig_id;
    const peticionCurso = this.$route.query.curso_id;

    axios
      .get(
        "tarea/obtenerTareasCursoAsignatura/" +
          this.routeasign +
          "/" +
          this.route,
        {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        }
      )
      .then((response) => {
        this.msg = response.data;
        console.log(response.data);
        vue.tareas = response.data;
        this.id = response.data[0].tareaId;

        this.descripcion = response.data[0].nombreTarea.substring(0, 25);

        this.fecha = response.data[0].fechTermino.substring(0, 10);

        this.hora = response.data[0].fechTermino.substring(11, 16);
        this.fechaEntrega = this.fecha + this.hora;
      })
      .catch((err) => console.log("No existen tareas asociadas")),
      axios
        .get(
          "/administracionCursos/mostrarAsignaturasCurso/" +
            this.$route.query.curso_id,
          {
            headers: {
              Authorization: localStorage.getItem("auth"),
            },
          }
        )
        .then((res) => {
          this.msg = res.data;
          vue.asig = res.data;
          console.log(vue.asig);
          vue.asig.forEach(function (valor, indice, array) {
            if (peticion == res.data[indice].asigId) {
              vue.responseAsig = res.data[indice];
            }
          });

          console.log(response.data.asignaturas[indice]);

          this.fechaEntrega = this.fecha + this.hora;
        })
        .catch((err) => {
          console.log("index not defined");
        });

    axios
      .get("adminitracionCursos/buscarCursos", {
        headers: {
          Authorization: localStorage.getItem("auth"),
        },
      })
      .then((response) => {
        vue.responseCurso = response.data;
        console.log(vue.responseCurso);
        vue.responseCurso.forEach(function (valor, indice, array) {
          if (peticionCurso == response.data[indice].cursoId) {
            vue.responseCurso = response.data[indice];
          }
        });
      });

    axios
      .get(
        "/administracionCursos/mostrarAsignaturasCurso/" +
          this.$route.query.curso_id,
        {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        }
      )
      .then((response) => {
        this.msg = response.data;
        vue.asig = response.data.asignaturas;
        vue.asig.forEach(function (valor, indice, array) {
          if (peticion == response.data.asignaturas[indice].asigId) {
            vue.responseCurso = response.data.asignaturas[indice];
          }
        });

        console.log(response.data.asignaturas[indice]);

        this.fechaEntrega = this.fecha + this.hora;
      })
      .catch((err) => {
        console.log("index not defined");
      });
      axios
        .get("cuentas/usuario", {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        })
        .then((resp) => {

          if (resp.data.rol == "DOCENTE") {
            this.elegirAsignaturaURL=
              "/ElegirAsignatura";
            this.elegirCursoURL=
            "/ElegirCurso";
            this.listaTareasURL=
            "/ListaTareasDocente"
          } else if (resp.data.rol == "ALUMNO") {
            this.elegirAsignaturaURL=
              "/ElegirAsignaturaAlumno";
            this.listaTareasURL=
            "/ListaTareasEstudiante"
          }

        });
  },
  methods: {
    eliminarTarea(id) {
      axios
        .delete("entregable/eliminarEntregablePorTarea/" + id)
        .then((response) => console.log(response));
      axios
        .delete("tarea/eliminarTarea/" + id)
        .then((response) => console.log(response));
        location.reload()
    },
    editarTarea() {},
  },
};
</script>
<style>

</style>
